Require Import Arith.

Fixpoint fact (n:nat) :=
  match n with
  | 0 => 1
  | S k => n * (fact k)
  end.

Fixpoint fact_tr_acc (n:nat) (acc:nat) :=
  match n with
  | 0 => acc
  | S k => fact_tr_acc k (n * acc)
  end.

Definition fact_tr (n:nat) :=
  fact_tr_acc n 1.

Lemma helper : forall (n acc : nat),
  fact_tr_acc n acc = (fact n) * acc.
Proof.
  intros n.
  induction n as [ | k IH]; intros acc.
  - simpl. ring.
  - simpl. rewrite IH. ring.
Qed.  

Theorem fact_tr_correct : forall n:nat,
  fact_tr n = fact n.
Proof.
  intros n. unfold fact_tr. rewrite helper. ring.
Qed.

Extract Inductive nat => int [ "0" "succ" ].
Extract Inlined Constant Init.Nat.mul => "(*)".
Extraction "fact.ml" fact_tr.